/**
 * @file Phase10Player.h
 *
 * @brief State data for Phase 10 player
 *
 * @ingroup CommonTypes
 *
 * @author Devon Johnson
 *
 */

#pragma once

// Includes
#include <functional>
#include <list>
#include <string>

#include <Phase10/CommonTypes.h>
#include <Phase10/User.h>

namespace Phase10
{
  //-------------------------------------------------------------------------//
  // Class:       Player
  // Description: State data for each player
  //-------------------------------------------------------------------------//
  class Player
  {
  public:
    // Public types
    using Listener = std::function<void()>;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Constructor
    /// @param pUser - player user
    /// @param pDrawPile - draw pile
    /// @param pDiscardPile - discard pile
    ///////////////////////////////////////////////////////////////////////////
    Player(const User* pUser, sDeck pDrawPile, sDeck pDiscardPile);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Destructor
    ///////////////////////////////////////////////////////////////////////////
    virtual ~Player() = default;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Adds a listener for updates to this deck
    /// @param listener - new listener to add
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void addListener(const Listener& listener);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Checks if this player can draw from discard
    /// @return - true if can draw from discard, else false
    ///////////////////////////////////////////////////////////////////////////
    bool canDrawFromDiscard() const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Discards a card
    /// @param card - card to discard
    /// @return - true if successful, else false
    ///////////////////////////////////////////////////////////////////////////
    bool discard(const Card& card);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Draws a card from the draw pile
    /// @return - true if successful, else false
    ///////////////////////////////////////////////////////////////////////////
    bool draw();

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Draws a card from the discard pile
    /// @return - true if successful, else false
    ///////////////////////////////////////////////////////////////////////////
    bool drawFromDiscard();

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the player's hand
    /// @return - this player's hand
    ///////////////////////////////////////////////////////////////////////////
    scDeck getHand() const { return mHand; }
    sDeck getHand() { return mHand; }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the player's phase
    /// @return - this player's phase
    ///////////////////////////////////////////////////////////////////////////
    scPhase getPhase() const { return mPhase; }
    sPhase getPhase() { return mPhase; }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the player's phase number
    /// @return - this player's phase number
    ///////////////////////////////////////////////////////////////////////////
    PhaseNumber getPhaseNum() const { return mPhaseNum; }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets a string representation of the phase
    /// @return - string representation of this player's phase
    ///////////////////////////////////////////////////////////////////////////
    std::string getPhaseString() const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the player state data
    /// @param playerID - player ID
    /// @param msg[out] - player state data
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void getPlayerState(Messages::PlayerStateMsg& msg) const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the player's score
    /// @return - this player's score
    ///////////////////////////////////////////////////////////////////////////
    size_t getScore() const { return mScore; }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the player's state
    /// @return - this player's state
    ///////////////////////////////////////////////////////////////////////////
    PlayerState getState() const { return mState; }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the player's user ID
    /// @return - player user ID
    ///////////////////////////////////////////////////////////////////////////
    uint32_t id() const { return mUser->id(); }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Checks if the player has completed their phase
    /// @return - true if completed, else false
    ///////////////////////////////////////////////////////////////////////////
    bool isPhaseComplete() const { return mPhaseComplete; }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets whether the player has been skipped
    /// @return - true if skipped, else false
    ///////////////////////////////////////////////////////////////////////////
    bool isSkipped() const { return mSkipped; }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the player's name
    /// @return - player name
    ///////////////////////////////////////////////////////////////////////////
    const std::string& name() const { return mUser->name(); }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Sets the deck mode for my hand
    /// @param mode - new deck mode
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void setMode(DeckMode mode);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the player state data
    /// @param msg - player state data
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void setPlayerState(const Messages::PlayerStateMsg& msg);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Skips the given player
    /// @param player - player to skip
    /// @return - true if successful, else false
    ///////////////////////////////////////////////////////////////////////////
    bool skipPlayer(Player& player);

  private:
    // Allow State to call state transition functions
    friend class Game;
    friend class State;

    // Private class variables
    const User* mUser;        ///< user associated with this player
    const sDeck mDrawPile;    ///< draw pile
    const sDeck mDiscardPile; ///< discard pile

    bool        mPhaseComplete; ///< has this player completed their phase?
    bool        mSkipped;       ///< has this player been skipped for this round?
    PlayerState mState;         ///< current state
    PhaseNumber mPhaseNum;      ///< phase number
    sPhase      mPhase;         ///< my current phase
    sDeck       mHand;          ///< my hand
    size_t      mScore;         ///< my score

    std::list<Listener> mListeners; ///< update listeners

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Advances to the next round
    /// @param reset - reset to first phase?
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void advanceRound(bool reset = false);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Draws from the specified deck
    /// @param deck - deck to draw from
    /// @return - true if successful, else false
    ///////////////////////////////////////////////////////////////////////////
    bool drawFrom(Deck& deck);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Ends the round
    /// @return - true if successful, else false
    ///////////////////////////////////////////////////////////////////////////
    bool endRound();

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Called when my hand or phase changes
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void handPhaseUpdate();

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Leaves the game
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void leave();

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Notifies all listeners that the deck has been updated
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void notify();

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Sets whether the phase is locked
    /// @param locked - true if locked, else false
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void setPhaseLocked(bool locked);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Sets this player to be skipped
    /// @return - true if successful, else false
    ///////////////////////////////////////////////////////////////////////////
    bool setSkipped();

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Starts the round
    /// @return - true if successful, else false
    ///////////////////////////////////////////////////////////////////////////
    bool startRound();

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Starts this player's turn
    /// @return - true if transitioned, else false
    ///////////////////////////////////////////////////////////////////////////
    bool startTurn();
  };

} // namespace Phase10
